<?php
//create dir install-tmp, copy friendlycms.current.zip => install.zip
define('DEBUG',0);
set_time_limit(0);
ini_set("Display_errors","off");
error_reporting(0);
define("INSTALLER_DOMAIN","http://license.frcms.ru");
$step = isset($_REQUEST['step']) ? intval($_REQUEST['step']):1;
$atest = (isset($_REQUEST['atest'])) ? 1 : 0;
$current_dir = dirname(__FILE__);

if($atest == 1) {
	$result = array();
	$testType = $_REQUEST['testtype'];
	if($testType == '1') {
		$license = trim($_POST['license']);
		$installto = ($_POST['installTo'] == '')?"":trim($_POST['installTo']);
		$dbhost = trim($_POST['dbhost']);
		$dbuser = trim($_POST['dbuser']);
		$dbpassword = trim($_POST['dbpassword']);
		$dbname = trim($_POST['dbname']);
		$installfromdownload = intval($_POST['installfromdownload']);
		$onlydownload = (isset($_POST['onlydownload']) && $_POST['onlydownload'] == 1) ? 1 : 0;
			
		$params = array(
			'dbhost'	=>	$dbhost,
			'dbuser'	=>	$dbuser,
			'dbpassword'	=>	$dbpassword,
			'dbname'	=>	$dbname
		);
		
		$lnk = connectDb($params);
		$result['db_connect'] = ($lnk !== false) ? 1 : 0;
		$result['db_select'] = ($lnk !== false) ? 1 : 0;
		
		$result['license'] = (int) checkLicense($license);
		$installtoFPath = $current_dir.$installto.'/install-tmp';
		$installtoFPath = formatPath($installtoFPath);
		if($installfromdownload == 0) {
			@rmdir($installtoFPath);
			if(@mkdir($installtoFPath,0777,true) !== false || file_exists($installtoFPath)){
				$result['directory'] = 1;
			} else {
				$result['directory'] = 0;
			}
			@rmdir($installtoFPath);
		} else {
			$result['directory'] = 1;
		}
		$result['success'] = 1;
		echo json_encode($result);
	}
	exit;
}
?>
<html>
<head>
<title>Установка FriendlyCMS</title>
<meta charset="utf-8">
<meta content="ie=edge" http-equiv="x-ua-compatible">
<meta content="template language" name="keywords">
<meta content="Admin dashboard html template" name="description">
<meta content="width=device-width, initial-scale=1" name="viewport">
<link href="favicon.png" rel="shortcut icon">
<link href="apple-touch-icon.png" rel="apple-touch-icon">
<link href="http://license.frcms.ru/installer/template/bower_components/select2/dist/css/select2.min.css" rel="stylesheet">
<link href="http://license.frcms.ru/installer/template/bower_components/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
<link href="http://license.frcms.ru/installer/template/bower_components/dropzone/dist/dropzone.css" rel="stylesheet">
<link href="http://license.frcms.ru/installer/template/bower_components/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
<link href="http://license.frcms.ru/installer/template/bower_components/fullcalendar/dist/fullcalendar.min.css" rel="stylesheet">
<link href="http://license.frcms.ru/installer/template/bower_components/perfect-scrollbar/css/perfect-scrollbar.min.css" rel="stylesheet">
<link href="http://license.frcms.ru/installer/template/bower_components/slick-carousel/slick/slick.css" rel="stylesheet">
<link href="http://license.frcms.ru/installer/template/css/main-version=4.4.1.css" rel="stylesheet">
<link href="http://license.frcms.ru/installer/template/icon_fonts_assets/font-awesome/css/font-awesome.min.css" rel="stylesheet">
<link href="http://license.frcms.ru/installer/template/css/custom.css" rel="stylesheet">
</head>
<body>
<?
$current_path = dirname(__FILE__);
if($step == 1) {
	$depend = true;
	$needExtensions = getNeedExtensions();
	?>
	<div class="content-i">
	<div class="content-box">
		<div class="row">
			<div class="col-lg-12">
				<div class="element-wrapper">
					<h1 class="element-header"><img src='http://license.frcms.ru/installer/template/img/logo_red.svg' /> Установка</h1>
						<div class="element-box">
							<h3 class="form-header">Шаг 1</h3>
							<div class="form-desc">Системные требования и подготовка к установке</div>
							
							<h5 class="form-header">Проверка наличия требуемых расширений веб-сервера</h5>
							<div class="form-group row">
								<div class='install'>
									<ul>
										<?
										foreach($needExtensions as $k => $v) {
											if($v === false) $depend = false;
											?>
											<li>
												<div class='dependItem'><?=$k?></div>
												<?=(($v === true)?"<div class='depend_value depend_accepted'><i class='fa fa-check'></i></div>":"<div class='depend_value depend_error'><i class='fa fa-times'></i></div>")?>
												<div class='clear'></div>
											</li>
											<?
										}
										?>
									</ul>
								</div>
							</div>
							<?
							if($depend === true) {
								?>
								<div class="alert alert-success" role="alert">
									<strong>Отлично! </strong>Все требуемые расширения найдены
								</div>
								
								<form id='preinstall' method='POST'>
								<input type='hidden' name='step' value='2'>
								<input type='hidden' name='installTo' value='/'>
								
								<h5 class="form-header">Параметры установки</h5>
							
								<div class="form-group row">
									<label class="col-form-label col-sm-4" for=""> Номер лицензии *</label>
									<div class="col-sm-8"><input name="license" class="form-control" placeholder="Укажите номер лицензии" type="text" value="12345RF" data-match-error="Необходимо указать номер лицензии" required="required"></div>
								</div>
								
								<div class="form-group row">
									<label class="col-form-label col-sm-4" for=""> Адрес сервера БД</label>
									<div class="col-sm-8"><input name="dbhost" class="form-control" placeholder="Укажите адрес сервера для подключения к БД" type="text" value="localhost"></div>
								</div>
								
								<div class="form-group row">
									<label class="col-form-label col-sm-4" for=""> Пользователь БД *</label>
									<div class="col-sm-8"><input name="dbuser" class="form-control" placeholder="Укажите имя пользователя для подключения к БД" type="text" value="" data-match-error="Необходимо указать имя пользователя для подключения к БД" required="required"></div>
								</div>
								
								<div class="form-group row">
									<label class="col-form-label col-sm-4" for=""> Пароль БД *</label>
									<div class="col-sm-8"><input name="dbpassword" class="form-control" placeholder="Укажите пароль пользователя для подключения к БД" type="text" value="" data-match-error="Необходимо указать пароль пользователя для подключения к БД" required="required"></div>
								</div>
								
								<div class="form-group row">
									<label class="col-form-label col-sm-4" for=""> Имя БД *</label>
									<div class="col-sm-8"><input name="dbname" class="form-control" placeholder="Укажите имя БД" type="text" value="" data-match-error="Необходимо указать имя БД" required="required"></div>
								</div>
								
								<div class="form-check">
									<label class="form-check-label">
										<input class="form-check-input" type="checkbox" name="onlydownload" value="1">Только скачать дистрибутив
									</label>
								</div>
								
								<div class="form-check">
									<label class="form-check-label">
										<input class="form-check-input" type="checkbox" name="installfromdownload" value="1">Установка из скачанного архива (install-tmp/install.zip)
									</label>
								</div>
								
								<div class="form-buttons-w">
									<button class="btn btn-primary" type="button" onclick='checkPreinstall();'> Начать установку</button>
								</div>
								</form>
								<?
							} else {
								?>
								<div class="alert alert-danger" role="alert">
									<strong>Ошибка! </strong>Не все требуемые расширения найдены на сервере
								</div>
								<?
							}
							?>
							
						</div>
				</div>
			</div>
		</div>
	</div>
	</div>
	<?
	tail();
}
if($step == 2) {
	$dbhost = trim($_POST['dbhost']);
	$dbuser = trim($_POST['dbuser']);
	$dbpassword = trim($_POST['dbpassword']);
	$dbname = trim($_POST['dbname']);
	$license = trim($_POST['license']);
	$installto = ($_POST['installTo'] == '')?"":trim($_POST['installTo']);
	$installfromdownload = intval($_POST['installfromdownload']);
	
	$license_dir = formatPath($current_dir.$installto."/core/license");
	$sql_dir = formatPath($current_dir.$installto."/sql");
		
	$installtoFPath = formatPath($current_dir.$installto.'/install-tmp');
	$installFile = $installtoFPath."/install.zip";
	
	$onlydownload = (isset($_POST['onlydownload']) && $_POST['onlydownload'] == 1) ? 1 : 0;
	
	$params = array(
		'dbhost'	=>	$dbhost,
		'dbuser'	=>	$dbuser,
		'dbpassword'	=>	$dbpassword,
		'dbname'	=>	$dbname,
		'license'	=>	$license,
		'installto'	=>	$installto,
		'onlydownload'	=>	$onlydownload,
		'installFPath'	=>	$installtoFPath,
		'step'	=>	2
	);
	$installFileDownload = $installto.'/install-tmp/install.zip';
	if($installfromdownload == 0) {
		@mkdir($installtoFPath,0777,true);
		@unlink($installFile);
		downloadInstallFile($installFile);
	}
	if($installfromdownload == 1 && !file_exists($installFile)) {
		errorMessage("Установочный файл не найден");
	}
	if($onlydownload == 1) {
		?>
		<div class="content-i">
			<div class="content-box">
				<div class="row">
					<div class="col-lg-12">
						<div class="element-wrapper">
							<h1 class="element-header"><img src='http://license.frcms.ru/installer/template/img/logo_red.svg' /> Установка</h1>
								<div class="element-box">
									<h3 class="form-header">Скачивание</h3>
									<div class="form-desc">Дистрибутив получен. Скачать его вы можете нажав на кнопку ниже</div>
									<a class="btn btn-primary" href='<?=$installFileDownload?>'>Скачать дистрибутив</a>
								</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<?
	} else {
		unzipData($params,$installFile,$installto);	
		createDatabase($params, $sql_dir);
		createLicense($params,$license_dir,$license);
		
		delTree($sql_dir);
		delTree($installtoFPath);
		
		createConfig($installto,$params);
		//if(DEBUG == 0) {
		//	setPermissions($installto);
		//}
		reportInstalled($license);
		?>
		
		<div class="content-i">
		<div class="content-box">
			<div class="row">
				<div class="col-lg-12">
					<div class="element-wrapper">
						<h1 class="element-header"><img src='http://license.frcms.ru/installer/template/img/logo_red.svg' /> Установка</h1>
							<div class="element-box">
								<form action='' method='POST' id="postinstall">
								<input type='hidden' name='step' value='3'>
								<input type='hidden' name='dbhost' value='<?=$params['dbhost']?>'>
								<input type='hidden' name='dbuser' value='<?=$params['dbuser']?>'>
								<input type='hidden' name='dbpassword' value='<?=$params['dbpassword']?>'>
								<input type='hidden' name='dbname' value='<?=$params['dbname']?>'>
								<input type='hidden' name='installto' value='<?=$installto?>'>
								<input type='hidden' id='set_permissions' name='set_permissions' value='0'>
								
								<h3 class="form-header">Шаг 2</h3>
								<div class="form-desc">Поздравляем ! Установка успешно завершена. Чтобы начать пользоваться системой, пожалуйста укажите логин и пароль администратора.</div>
									
								<div class="form-group row">
									<label class="col-form-label col-sm-4" for=""> Логин *</label>
									<div class="col-sm-8"><input name="login" class="form-control" placeholder="Укажите логин администратора" type="text" value="" data-match-error="Необходимо указать логин администратора" required="required"></div>
								</div>
								
								<div class="form-group row">
									<label class="col-form-label col-sm-4" for=""> Адрес электронной почты *</label>
									<div class="col-sm-8"><input name="email" class="form-control" placeholder="Укажите адрес электронной почты" type="text" value="" data-match-error="Необходимо указать адрес электронной почты" required="required"></div>
								</div>
								
								<div class="form-group row">
									<label class="col-form-label col-sm-4" for=""> Пароль *</label>
									<div class="col-sm-8"><input name="password" id="password" class="form-control" type="password" value="" data-match-error="Необходимо указать пароль администратора" required="required"></div>
								</div>
								
								<div class="form-group row">
									<label class="col-form-label col-sm-4" for=""> Подтверждение пароля *</label>
									<div class="col-sm-8"><input name="password2" id="password2" class="form-control" type="password" value="" data-match-error="Необходимо подтвердить пароль" required="required"></div>
								</div>
								
								<div class="form-buttons-w">
									<button class="btn btn-primary" type="button" onclick="validatePasswords(1);"> Применить и автоматически установить оптимальные права доступа на папки</button>
									
									&nbsp;
									
									<button class="btn btn-primary" type="button" onclick="validatePasswords(0);"> Применить и перейти к панели управления</button>
								</div>
								
								<div><br />Рекомендуем выбирать автоматическую установку прав в том случае, если вам не требуется что то дополнительно изменять в коде и шаблонах сайта. Это действие усиливает защиту сайта от взлома.</div>
								
								</form>
								
							</div>
					</div>
				</div>
			</div>
		</div>
		</div>
		<?
	}
	tail();
}

if($step == 3) {
	$dbhost = $_POST['dbhost'];
	$dbuser = $_POST['dbuser'];
	$dbpassword = $_POST['dbpassword'];
	$dbname = $_POST['dbname'];
	$set_permissions = (int) $_POST['set_permissions'];
	$login = trim($_POST['login']);
	$password = trim($_POST['password']);
	$email = trim($_POST['email']);
	$installto = ($_POST['installTo'] == '')?"":trim($_POST['installTo']);
	
	$params = array(
		'dbhost'	=>	$dbhost,
		'dbuser'	=>	$dbuser,
		'dbpassword'	=>	$dbpassword,
		'dbname'	=>	$dbname,
		'step'	=>	3,
		'login' => $login,
		'password' => $password,
		'email' => $email,
		'installto'	=>	$installto,
	);
	changeAdminPassword($params);
	$persmissions_error = 0;
	try {
		if($set_permissions == 1) {
			setPermissions($installto);
		}
	} catch(Exception $e) {
		$persmissions_error = 1;
	}
	
	?>
	<div class="content-i">
		<div class="content-box">
			<div class="row">
				<div class="col-lg-12">
					<div class="element-wrapper">
						<h1 class="element-header"><img src='http://license.frcms.ru/installer/template/img/logo_red.svg' /> Установка</h1>
							<div class="element-box">
								<h3 class="form-header">Все готово</h3>
								<div class="form-desc">Установка завершена успешно !</div>
								<?
								if($set_permissions == 1) {
									if($persmissions_error == 0) {
										?>
										<div class="alert alert-success" role="alert">
											Требуемые права доступа на папки были успешно установлены
										</div>
										<?
									} else {
										?>
										<div class="alert alert-danger" role="alert">
											<strong>Ошибка</strong> Во время установки прав доступа произошла ошибка. Рекомендуется сделать это вручную через файловый менеджер.
											
										</div>
										<?
									}
									
								}
								?>
								<a class="btn btn-primary" href='/adm'>Перейти в панель администрирования</a>
							</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<?
	tail();
}

function getNeedExtensions() {
	$serverExtensions = get_loaded_extensions();
	$needExtensions = array(	
		//'Серверный модуль ionCube'	=>	((in_array('ionCube Loader', $serverExtensions)) ? true : false),
		//'Версия PHP'	=> ((version_compare(PHP_VERSION, '5.4.0') >= 0) ? true : false),
		'Версия PHP'	=> ((version_compare(PHP_VERSION, '5.2.0') >= 0) ? true : false),
		'Расширение PHP bz2'	=>	((in_array('bz2', $serverExtensions)) ? true : false),
		'Расширение PHP curl'	=>	((in_array('curl', $serverExtensions)) ? true : false),
		'Расширение PHP date'	=>	((in_array('date', $serverExtensions)) ? true : false),
		'Расширение PHP gd'	=>	((in_array('gd', $serverExtensions)) ? true : false),
		'Расширение PHP iconv'	=>	((in_array('iconv', $serverExtensions)) ? true : false),
		'Расширение PHP json'	=>	((in_array('json', $serverExtensions)) ? true : false),
		'Расширение PHP mbstring'	=>	((in_array('mbstring', $serverExtensions)) ? true : false),
		'Расширение PHP pcre'	=>	((in_array('pcre', $serverExtensions)) ? true : false),
		//'Расширение PHP pdf'	=>	((in_array('pdf', $serverExtensions)) ? true : false),
		'Расширение PHP zip'	=>	((in_array('zip', $serverExtensions)) ? true : false),
		'Расширение PHP zlib'	=>	((in_array('zlib', $serverExtensions)) ? true : false),
		'Расширение PHP xml'	=>	((in_array('xml', $serverExtensions)) ? true : false),
		'Расширение PHP xmlreader'	=>	((in_array('xmlreader', $serverExtensions)) ? true : false),
		'Расширение PHP xmlwriter'	=>	((in_array('xmlwriter', $serverExtensions)) ? true : false),
		'Расширение PHP SimpleXML'	=>	((in_array('SimpleXML', $serverExtensions)) ? true : false),
		'Расширение PHP session' =>	((in_array('session', $serverExtensions)) ? true : false),
		'Расширение PHP libxml' =>	((in_array('libxml', $serverExtensions)) ? true : false)
	);
	
	if(version_compare(PHP_VERSION, '5.4') <= 0) {
		$needExtensions['Расширение PHP mysql'] = ((in_array('mysql', $serverExtensions)) ? true : false);
	}
	if(version_compare(PHP_VERSION, '5.4') > 0) {
		$needExtensions['Расширение PHP mysqli'] = ((in_array('mysqli', $serverExtensions)) ? true : false);
		$needExtensions['Расширение PHP PDO'] = ((in_array('PDO', $serverExtensions)) ? true : false);
	}
	return $needExtensions;
}

function changeAdminPassword($params) {
	$login = $params['login'];
	$password = $params['password'];
	$email = $params['email'];
	
	$lnk = connectDb($params);
	if(!$lnk) {
		sendReport(array_merge($params,array('error' =>	'Ошибка соединения с сервером баз данных')));
		errorMessage('Ошибка соединения с сервером баз данных');
	}
	
	$salt = substr(md5(time().rand(10000,99999)),0,10);
	$newpass = md5(md5($password).$salt);
	$sql = "update users set login='$login', pass = '$newpass', mail = '$email', salt='$salt', active=1 where login='admin'";
	$res = mysqli_query($lnk, $sql);
	if(!$res){
		sendReport(array_merge($params,array('error' =>	'Ошибка применения нового логина и пароля администратора, '.$sql)));
		errorMessage('Ошибка применения нового логина и пароля администратора ');
	}
	
	$res = mysqli_query($lnk, "select * from users where login='$login'");
	$rec = mysqli_fetch_array($res,MYSQLI_ASSOC);
	$admin_id = $rec['user_id'];
	
	mysqli_query($lnk, "delete from users_acls");
	$res = mysqli_query($lnk, "select nav_id from navigation");
	while($rec = mysqli_fetch_array($res,MYSQLI_ASSOC)) {
		$module_id = $rec['nav_id'];
		$sql = "insert into users_acls (`module_id`,`user_id`,`r`,`e`,`d`) values($module_id,$admin_id,1,1,1)";
		mysqli_query($lnk,$sql);
	}
}


function createConfig($installto,$params) {
	$current_dir = dirname(__FILE__);
	$lnk = connectDb($params);
	mysqli_query($lnk, "update tech_config set config_value = '$installto' where config_name = 'installdir'");
	$configdata = file_get_contents($current_dir.$installto."/includes/db.inc.sample.php");
	$configdata = str_replace("{%DBHOST%}",$params['dbhost'],$configdata);
	$configdata = str_replace("{%DBUSER%}",$params['dbuser'],$configdata);
	$configdata = str_replace("{%DBPASSWORD%}",$params['dbpassword'],$configdata);
	$configdata = str_replace("{%DBNAME%}",$params['dbname'],$configdata);
	$fp2 = fopen($current_dir.$installto."/includes/db.inc.php","w");
	if(!$fp2) {
		sendReport(array_merge($params,array('error' =>	'config write error ')));
		errorMessage('Ошибка генерации конфигурационного файла');
	}
	fwrite($fp2,$configdata);
	fclose($fp2);
}

function downloadInstallFile($installFile) {
	$installscript = INSTALLER_DOMAIN."/latest/friendlycms.current.zip";
	if(file_exists(dirname($installFile)."/friendlycms.current.zip")) {
		rename(dirname($installFile)."/friendlycms.current.zip", $installFile);
	}
	
	if(!file_exists($installFile)) {
	$fp = fopen($installFile, 'w+');
		if(!$fp) {
			sendReport(array_merge($params,array('error' =>	'Ошибка создания файла инсталляции')));
			errorMessage("Ошибка создания файла инсталляции");
		}
		$ch = curl_init($installscript);
		curl_setopt($ch, CURLOPT_TIMEOUT, 0);
		curl_setopt($ch, CURLOPT_FILE, $fp);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		curl_exec($ch);
		curl_close($ch);
		fclose($fp);
	}
}
	
function createLicense($params,$license_dir,$license) {
	//create license file
	$licensedata = $license;
	if(!file_exists($license_dir)) mkdir($license_dir,0755);
	$fp = fopen($license_dir."/".md5($license).".lic","w+");
	if(!$fp) {
		sendReport(array_merge($params,array('error' =>	'Ошибка записи лицензии')));
		errorMessage("Ошибка записи лицензии");
	}
	fwrite($fp,$licensedata);
	fclose($fp);
	
	$lnk = connectDb($params);
	if(!$lnk) {
		sendReport(array_merge($params,array('error' =>	'Ошибка соединения с сервером баз данных')));
		errorMessage('Ошибка соединения с сервером баз данных');
	}
	
	mysqli_query($lnk, "update config set config_value = '$license' where config_name = 'license_key'");
	//
}

function createDatabase($params, $sql_dir) {
	$sql_dir_1 = $sql_dir."/1";
	$sql_dir_2 = $sql_dir."/2";
	$sql_dir_3 = $sql_dir."/3";
	
	$lnk = connectDb($params);
	if(!$lnk) {
		sendReport(array_merge($params,array('error' =>	'Ошибка соединения с сервером баз данных')));
		errorMessage('Ошибка соединения с сервером баз данных');
	}
	
	$result = dropAllTables($params);
	
	if(!$result) {
		sendReport(array_merge($params,array('error' =>	'Ошибка очистки таблицв базе данных')));
		errorMessage('Ошибка очистки таблиц в базе данных. Проверьте права доступа пользователя (DROP)');
	}
	
	//SQL 1 Structure
	$handle = opendir($sql_dir_1);
	if($handle)
		while (false !== ($entry = readdir($handle))) {
			if($entry != "." && $entry != "..") {
				if(strpos($entry,".sql") !== false) {
					$script = file_get_contents($sql_dir_1 . '/' . $entry);
					$queries = createQueries(trim($script));
					foreach($queries as $qk => $qv) {
						$res = mysqli_query($lnk, $qv) or die("script $entry $qv");
						if(!$res) {
							sendReport(array_merge($params,array('error' =>	'SQL:'.mysqli_error($lnk))));
							if(DEBUG == 1) {
								errorMessage(mysqli_error($lnk)." (script $entry $qv)");
							} else {
								errorMessage(mysqli_error($lnk)." (script $entry)");
							}
							
						}
					}
				}
			}
		}
	//SQL 2 Data
	$handle = opendir($sql_dir_2);
	if($handle)
		while (false !== ($entry = readdir($handle))) {
			if($entry != "." && $entry != "..") {
				if(strpos($entry,".sql") !== false) {
					$script = file_get_contents($sql_dir_2 . '/' . $entry);
					$queries = createQueries(trim($script));
					foreach($queries as $qk => $qv) {
						$res = mysqli_query($lnk, $qv) or die("script $entry ".((DEBUG == 1)?$qv:""));
						if(!$res) {
							sendReport(array_merge($params,array('error' =>	'SQL:'.mysqli_error($lnk))));
							if(DEBUG == 1) {
								errorMessage(mysqli_error($lnk)." (script $entry $qv)");
							} else {
								errorMessage(mysqli_error($lnk)." (script $entry)");
							}
							
						}
					}
				}
			}
		}
	
	//SQL 3 Updates
	$handle = opendir($sql_dir_3);
	if($handle)
		while (false !== ($entry = readdir($handle))) {
			if($entry != "." && $entry != "..") {
				if(strpos($entry,".sql") !== false) {
					$script = file_get_contents($sql_dir_3 . '/' . $entry);
					$queries = createQueries(trim($script));
					foreach($queries as $qk => $qv) {
						$res = mysqli_query($lnk, $qv) or die("script $entry ".((DEBUG == 1)?$qv:""));
						if(!$res) {
							sendReport(array_merge($params,array('error' =>	'SQL:'.mysqli_error($lnk))));
							if(DEBUG == 1) {
								errorMessage(mysqli_error($lnk)." (script $entry $qv)");
							} else {
								errorMessage(mysqli_error($lnk)." (script $entry)");
							}
							
						}
					}
				}
			}
		}
}

function unzipData($params,$installFile,$installto) {
	$current_dir = dirname(__FILE__);
	$unzip_result = unzip($installFile,$current_dir.$installto, false);
	if($unzip_result === false) {
		sendReport(array_merge($params,array('error' =>	'Ошибка распаковки, попробуйте начать установку сначала')));
		errorMessage("Ошибка распаковки, попробуйте начать установку сначала");
	} 
}

function setPermissions($installto) {
	$current_dir = dirname(__FILE__);
	chmod($current_dir.$installto."/includes/db.inc.php", 0555);
	setPermissionsRecursive($current_dir.$installto."/adm",0555);
	setPermissionsRecursive($current_dir.$installto."/cache",0777);
	setPermissionsRecursive($current_dir.$installto."/core",0555);
	setPermissionsRecursive($current_dir.$installto."/design",0555);
	setPermissionsRecursive($current_dir.$installto."/images",0555);
	setPermissionsRecursive($current_dir.$installto."/images/manufacturer",0777);
	setPermissionsRecursive($current_dir.$installto."/images/products",0777);
	setPermissionsRecursive($current_dir.$installto."/images/site_images",0777);
	setPermissionsRecursive($current_dir.$installto."/images/uploads",0777);
	setPermissionsRecursive($current_dir.$installto."/import",0777);
	setPermissionsRecursive($current_dir.$installto."/export",0777);
	setPermissionsRecursive($current_dir.$installto."/uploads",0555);
	setPermissionsRecursive($current_dir.$installto."/uploads/attachments",0777);
	setPermissionsRecursive($current_dir.$installto."/uploads/sitemaps",0777);
	setPermissionsRecursive($current_dir.$installto."/yml",0777);
	setPermissionsRecursive($current_dir.$installto."/includes",0555);
	setPermissionsRecursive($current_dir.$installto."/js",0555);
	chmod($current_dir.$installto."/index.php",0555);
	chmod($current_dir.$installto."/ajax.php",0555);
	chmod($current_dir.$installto."/.htaccess",0555);
	chmod($current_dir.$installto."/favicon.ico",0555);
	chmod($current_dir.$installto."/404.htm",0555);
}

function errorMessage($message) {
	?>
	<div class="content-i">
		<div class="content-box">
			<div class="row">
				<div class="col-lg-12">
					<div class="element-wrapper">
						<h1 class="element-header"><img src='http://license.frcms.ru/installer/template/img/logo_red.svg' /> Установка</h1>
							<div class="element-box">
								<h3 class="form-header">Ошибка</h3>
								<div class="form-desc">В процессе установки произошла ошибка !</div>
								<div class="alert alert-danger" role="alert">
									<strong>Ошибка! </strong><?=$message?>
								</div>
							</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<?
	tail();
	exit;
}

function setPermissionsRecursive($start_dir,$permissions = '0555') {
	$start_dir = str_replace("//","/",$start_dir);
	@chmod($start_dir,$permissions);
	$handle = @opendir($start_dir);
	if(!$handle) return false;
	while (false !== ($entry = readdir($handle))) {
		if($entry != "." && $entry != ".." && $entry != '') {
			if(is_dir($start_dir."/".$entry)) {
				setPermissionsRecursive($start_dir."/".$entry,$permissions);
			}
		}
	}
}

function createQueries($file) {
	$q = array();
	$queries = explode("--//--",trim($file));
	if(count($queries) == 0) {
		$queries = array($file);
	}
	foreach($queries as $query) {
		if(trim($query) == '') continue;
		$query = preg_replace('/\s\s+/', ' ', $query);
		while(strpos($query, "  ") !== false) {
			$query = str_replace("  "," ",$query);
		}
		$query = str_replace("--","- - ",$query);
		$query = trim($query);
		if(substr($query,-1) != ';') $query = $query.';';
		if($query != '') $q[] = $query;
	}
	return $q;
}

function checkLicense($license) {
	try {
		$ch = curl_init(INSTALLER_DOMAIN."/checklicense.php?lic=".urlencode($license));
		curl_setopt($ch, CURLOPT_TIMEOUT, 0);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
		$result = curl_exec($ch);
		curl_close($ch);
		return $result; // 1 OR 0
	} catch (Exception $e) {
		return -1;
	}
}

function reportInstalled($license) {
	try {
		$ch = curl_init(INSTALLER_DOMAIN."/checklicense.php?report=".urlencode($license)."&host=".$_SERVER['HTTP_HOST']);
		curl_setopt($ch, CURLOPT_TIMEOUT, 0);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
		$result = curl_exec($ch);
		curl_close($ch);
		return $result; // 1 OR 0
	} catch (Exception $e) {
		return -1;
	}
}

function sendReport($params) {
	$domain = $_SERVER['HTTP_HOST'];
	$params['domain'] = $domain;
	try {
		$ch = curl_init(INSTALLER_DOMAIN."/bugreport.php?oninstall=1");
		curl_setopt($ch, CURLOPT_TIMEOUT, 0);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		$postdata = "";
		foreach ($params as $key => $value)
			$postdata .= "&".rawurlencode($key)."=".rawurlencode($value);
		$postdata = substr($postdata, 1);
		curl_setopt($ch,CURLOPT_POST,1);
		curl_setopt($ch,CURLOPT_POSTFIELDS,$postdata);
		$result = curl_exec($ch);
		curl_close($ch);
		return $result; // 1 OR 0
	} catch (Exception $e) {
		return -1;
	}
}

function unzip($src_file, $dest_dir=false, $create_zip_name_dir=true, $overwrite=true) {
  if ($zip = zip_open($src_file)) {
    if ($zip) {
      $splitter = ($create_zip_name_dir === true) ? "." : "/";
      if ($dest_dir === false) $dest_dir = substr($src_file, 0, strrpos($src_file, $splitter))."/";
      create_dirs($dest_dir);
      while ($zip_entry = zip_read($zip)) {
        $pos_last_slash = strrpos(zip_entry_name($zip_entry), "/");
        if ($pos_last_slash !== false) {
          // Create the directory where the zip-entry should be saved (with a "/" at the end)
          create_dirs($dest_dir.substr(zip_entry_name($zip_entry), 0, $pos_last_slash+1));
        }
        if (zip_entry_open($zip,$zip_entry,"r")) {
          $file_name = $dest_dir.zip_entry_name($zip_entry);
          if ($overwrite === true || $overwrite === false && !is_file($file_name)) {
            $fstream = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
           	@file_put_contents($file_name, $fstream );
			chmod($file_name, 0777);
          }
          zip_entry_close($zip_entry);
        }
      }
      zip_close($zip);
    }
  } else {
    return false;
  } 
  return true;
}

function create_dirs($path) {
  if (!is_dir($path)) {
    $directory_path = "";
    $directories = explode("/",$path);
    array_pop($directories);
    
    foreach($directories as $directory) {
      $directory_path .= $directory."/";
      if (!is_dir($directory_path)) {
        $res = mkdir($directory_path);
        chmod($directory_path, 0777);
		if(!$res) {
			errorMessage("Ошибка создания каталога $directory_path");
		}
      }
    }
  }
}

function formatPath($installtoFPath) {
	
	while(strpos($installtoFPath,"//") !== false) {
		$installtoFPath = str_replace('//','/',$installtoFPath);
	}
	
	while(strpos($installtoFPath,"..") !== false) {
		$installtoFPath = str_replace('..','.',$installtoFPath);
	}
	
	//if(substr($installtoFPath,0,1) == '/' && strlen($installtoFPath) > 1) {
	//	$installtoFPath = substr($installtoFPath,1);
	//}
	
	//if(substr($installtoFPath,0,1) == '/' && strlen($installtoFPath) == 1) {
	//	$installtoFPath = '.'.$installtoFPath;
	//}
	
	return $installtoFPath;
}

function delTree($dir) { 
    $files = array_diff(scandir($dir), array('.','..')); 
    foreach ($files as $file) { 
      (is_dir("$dir/$file")) ? delTree("$dir/$file") : unlink("$dir/$file"); 
    } 
    return rmdir($dir); 
} 

function uninstall($dir){
	$handle = opendir($dir); 	
	while (false !== ($entry = readdir($handle))) {
		if($entry != "." && $entry != "..") {
			if(is_dir($entry)) {
				delTree($entry);
			} else {
				if($entry !== __FILE__) {
					@unlink($dir."/".$entry);
				}
			}
		}
	}	
}

function dropAllTables($params) {
	$lnk = connectDb($params);
	$errors = 0;
	$res = mysqli_query($lnk, "SHOW TABLE STATUS FROM `".$params['dbname']."`");
	while($row = mysqli_fetch_array($res,MYSQLI_ASSOC)) {
		$table_name = $row['Name'];
		if(!mysqli_query($lnk, "drop table if exists `".$table_name."`")) {
			$errors++;
		}
	}
	if($errors) return false;
	
	return true;
}

function connectDb($params) {
	$dbhost  = $params['dbhost'];
	$dbuser = $params['dbuser'];
	$dbpassword = $params['dbpassword'];
	$dbname = $params['dbname'];
	$lnk = @mysqli_connect($dbhost,$dbuser,$dbpassword,$dbname);
	if(!$lnk) {
		return false;
	}
	mysqli_query($lnk, "set names utf8");
	return $lnk;
}

function tail() {
	?>
	<script>
	function checkPreinstall() {
		var formdata = $("#preinstall").serialize();
		formdata = formdata + "&testtype=1&atest=1";
		$.post("webinstaller.php",formdata ,function(data){
		if(data.success == 1) {
			var e = "";
			if(data.db_connect == 0) {
				e += "Ошибка подключения к серверу MySQL \r\n";
			}
			if(data.db_select == 0) {
				e += "Ошибка подключения к базе данных \r\n";
			}
			if(data.license == 0) {
				e += "Неверный код лицензии \r\n";
			}
			if(data.license == -1) {
				e += "Ошибка подключения к серверу лицензий \r\n";
			}
			if(data.directory == 0) {
				e += "Ошибка проверки прав записи в каталог установки \r\n";
			}
			
			if(e == '') {
				$("#preinstall").submit();
			} else {
				alert(e);
			}
			
		} else {
			alert('В процессе проверки условий установки произошла ошибка.');
		}
		},"json");
	}

	function validatePasswords(set_permissions) {
		var e = '';
		var passw = $("#password").val();
		var passw2 = $("#password2").val();
		if(passw != passw2) {
			e += "Пароли не совпадают\r\n";
		}
		if(e != '') {
			alert(e);
			return false;
		}
		$("#set_permissions").val(set_permissions);
		$("#postinstall").submit();
	}
	</script>
	<script src="http://license.frcms.ru/installer/template/bower_components/jquery/dist/jquery.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/popper.js/dist/umd/popper.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/moment/moment.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/chart.js/dist/Chart.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/select2/dist/js/select2.full.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/jquery-bar-rating/dist/jquery.barrating.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/ckeditor/ckeditor.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap-validator/dist/validator.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap-daterangepicker/daterangepicker.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/dropzone/dist/dropzone.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/editable-table/mindmup-editabletable.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/datatables.net/js/jquery.dataTables.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/fullcalendar/dist/fullcalendar.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/perfect-scrollbar/js/perfect-scrollbar.jquery.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/tether/dist/js/tether.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/slick-carousel/slick/slick.min.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/util.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/alert.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/button.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/carousel.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/collapse.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/dropdown.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/modal.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/tab.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/tooltip.js"></script>
	<script src="http://license.frcms.ru/installer/template/bower_components/bootstrap/js/dist/popover.js"></script>
	<script src="http://license.frcms.ru/installer/template/js/main-version=4.4.1.js"></script>
	</body>
	</html>
	<?
}
